#include <iostream>

using namespace std;
int nDelete = 0;	// antalet anrop till Nod::~Nod()

class Nod {
public:
	int data;
	Nod *vanster, *hoger;
	Nod(int d = 0, Nod *v = nullptr, Nod *h = nullptr)
		: data(d), vanster(v), hoger(h) {}
	~Nod() { ++nDelete; delete vanster; delete hoger; }
};

// Utskrift av deltrd med rot p i in-order
void inorder(Nod *p) {
	if (p != nullptr) {
		inorder(p->vanster);
		cout << p->data << ' ';
		inorder(p->hoger);
	}
}

// Utskrift av deltrd med rot p i pre-order
void preorder(Nod *p) {
	if (p != nullptr) {
		cout << p->data << ' ';
		preorder(p->vanster);
		preorder(p->hoger);
	}
}

// Utskrift av deltrd med rot p i post-order
void postorder(Nod *p) {
	if (p != nullptr) {
		postorder(p->vanster);
		postorder(p->hoger);
		cout << p->data << ' ';
	}
}

int djup(Nod *r) {
	if (r == nullptr)
		return 0;
	else {
		int vdjup = djup(r->vanster);
		int hdjup = djup(r->hoger);
		if (vdjup > hdjup)
			return vdjup + 1;
		else
			return hdjup + 1;
	}
}

Nod* sok(Nod *r, int sokt) {
	if (r == nullptr)
		return nullptr;
	else if (sokt == r->data)
		return r;
	else if (sokt < r->data)
		return sok(r->vanster, sokt);
	else if (sokt > r->data)
		return sok(r->hoger, sokt);
}

// Tm deltrd med rot p i post-order (med destruktor)
void tom(Nod *&p) {
	nDelete = 0;	// nollstll rknare
	delete p;		// gr ven delete p resp deltrd
	p = nullptr;
}

// Tm deltrd med rot p i post-order (utan destruktor)
//void tom(Nod *&p) {
//	if (p != nullptr) {
//		tom(p->vanster);
//		tom(p->hoger);
//		delete p;
//		p = nullptr;
//	}
//}

int main() {
	// ... skapa ett litet binrtrd
	Nod *rot = new Nod(4);
	rot->vanster = new Nod(2);
	rot->hoger = new Nod(7);

	inorder(rot);	cout << endl;

	tom(rot);
	cout << "Borttagna noder: " << nDelete << endl;

	rot = new Nod(11, new Nod(7, new Nod(3, nullptr, new Nod(4)),
								 new Nod(9)
							 ),
					  new Nod(16, new Nod(13, new Nod(12), nullptr),
								  new Nod(19, new Nod(17), new Nod (21))
							 )
				 );

	inorder(rot);	cout << endl;
	preorder(rot);	cout << endl;
	postorder(rot);	cout << endl;

	tom(rot);
	cout << "Borttagna noder: " << nDelete << endl;

	cout << "Size of Nod " << sizeof(Nod) << endl;
	cout << "Size of pointer " << sizeof(Nod *) << endl;

	cin >> ws;
}
