#include <iostream>
#include <memory>

using namespace std;
int nDelete = 0;	// antalet anrop till Nod::~Nod()

class Nod {
public:
	int data;
	shared_ptr<Nod> vanster, hoger;
	Nod(int d = 0, shared_ptr<Nod> v = nullptr, 
		shared_ptr<Nod> h = nullptr)
		: data(d), vanster(v), hoger(h) {}
	~Nod() { ++nDelete; }	// shared_ptr ser till noderna 
							// i deltrden tas bort nr
							// inga pekare finns kvar p dem
};

// Utskrift av deltrd med rot p i in-order
void inorder(shared_ptr<Nod> p) {
	if (p != nullptr) {
		inorder(p->vanster);
		cout << p->data << ' ';
		inorder(p->hoger);
	}
}

// Utskrift av deltrd med rot p i pre-order
void preorder(shared_ptr<Nod> p) {
	if (p != nullptr) {
		cout << p->data << ' ';
		preorder(p->vanster);
		preorder(p->hoger);
	}
}

// Utskrift av deltrd med rot p i post-order
void postorder(shared_ptr<Nod> p) {
	if (p != nullptr) {
		postorder(p->vanster);
		postorder(p->hoger);
		cout << p->data << ' ';
	}
}

int djup(shared_ptr<Nod> r) {
	if (r == nullptr)
		return 0;
	else {
		int vdjup = djup(r->vanster);
		int hdjup = djup(r->hoger);
		if (vdjup > hdjup)
			return vdjup + 1;
		else
			return hdjup + 1;
	}
}

shared_ptr<Nod> sok(shared_ptr<Nod> r, int sokt) {
	if (r == nullptr)
		return nullptr;
	else if (sokt == r->data)
		return r;
	else if (sokt < r->data)
		return sok(r->vanster, sokt);
	else if (sokt > r->data)
		return sok(r->hoger, sokt);
}

// Tm deltrd med rot p i post-order (med destruktor)
void tom(shared_ptr<Nod> &p) {
	nDelete = 0;	// nollstll rknare
	p = nullptr;	// destruktorn till Nod anropas
					// som anropar destruktorerna fr 
					// vanster och hoger (som anropar...)
}

int main() {
	// ... skapa ett litet binrtrd
	shared_ptr<Nod> rot = make_shared<Nod>(4);
	rot->vanster = make_shared<Nod>(2);
	rot->hoger = make_shared<Nod>(7);

	inorder(rot);	cout << endl;

	tom(rot);
	cout << "Borttagna noder: " << nDelete << endl;

	rot = make_shared<Nod>(11, make_shared<Nod>(7, make_shared<Nod>(3, nullptr, 
																	make_shared<Nod>(4)),
												   make_shared<Nod>(9)
							 ),
							   make_shared<Nod>(16, make_shared<Nod>(13, make_shared<Nod>(12), 
																		 nullptr),
												    make_shared<Nod>(19, make_shared<Nod>(17), 
																		 make_shared<Nod>(21))
							 )
				 );

	inorder(rot);	cout << endl;
	preorder(rot);	cout << endl;
	postorder(rot);	cout << endl;

	tom(rot);
	cout << "Borttagna noder: " << nDelete << endl;

	cout << "Size of Nod " << sizeof(Nod) << endl;
	cout << "Size of shared_ptr " << sizeof(shared_ptr<Nod>) << endl;

	cin >> ws;
}
