#include <iostream>
using namespace std;

// <<<<<<<<<<<<<<<< slide 1 >>>>>>>>>>>>>>>>>>>>>>
class Element {
public:
	Element *nasta;
	int data;
	Element(Element *n, int d) : nasta(n), data(d) {}
};

void skriv(Element *forsta) {
	for (Element *p = forsta; p != nullptr; p = p->nasta)
		cout << p->data << ' ';
}

void tom(Element *& forsta) {
	while (forsta != nullptr) {// G igenom och ta bort
		Element *p = forsta;
		forsta = forsta->nasta;
		delete p;
	}
}

void test1() {
	Element *forsta = nullptr; // Brja med tom lista
	forsta = new Element(forsta, 2); // 1:a elem
	forsta = new Element(forsta, 5); // 2:a elem
	forsta = new Element(forsta, 4); // 3:e elem
	// forsta pekar p sist inlagda elem.(3:e)

	skriv(forsta);   cout << endl;
	tom(forsta);
	skriv(forsta);   cout << endl;
}

// <<<<<<<<<<<<<<<< slide 2 >>>>>>>>>>>>>>>>>>>>>>
Element *sok(Element *forsta, int sokt) {
	Element *p;
	for (p = forsta; p && p->data != sokt; p = p->nasta) {}
	return p;
}

void lagg_forst(Element *& forsta, int d) {
	forsta = new Element(forsta, d);
}

// <<<<<<<<<<<<<<<< slide 3 >>>>>>>>>>>>>>>>>>>>>>
void lagg_sist(Element *& forsta, int d) {
	if (!forsta) // tom lista
		forsta = new Element(nullptr, d);
	else {
		Element *p;
		for (p = forsta; p->nasta; p = p->nasta)
			;
		p->nasta = new Element(nullptr, d);
	}
}

void test23() {
	Element *forsta = nullptr; // Brja med tom lista

	Element *e = sok(forsta, 5); // Sk i tom lista

	lagg_forst(forsta, 2);
	lagg_forst(forsta, 5);
	lagg_forst(forsta, 4);
	skriv(forsta);   cout << endl;

	e = sok(forsta, 5);		// Sk efter element som finns
	e = sok(forsta, 7);		// Sk efter element som inte finns

	lagg_sist(forsta, 7);
	skriv(forsta);   cout << endl;
	e = sok(forsta, 5);		// Sk efter element som finns
	e = sok(forsta, 7);		// Sk efter element som nu finns

	tom(forsta);
}

// <<<<<<<<<<<<<<<< slide 4 >>>>>>>>>>>>>>>>>>>>>>
//Skriva ut lista baklnges mha rekursion
void skriv_baklanges(Element *forsta) {
	if (forsta) {
		skriv_baklanges(forsta->nasta);
		std::cout << forsta->data << ' ';
	}
}

// Lgg in sist i lista mha rekursion
void lagg_sist_rek(Element *& forsta, int d) {
	if (!forsta)
		forsta = new Element(nullptr, d);
	else
		lagg_sist_rek(forsta->nasta, d);
}

//Skriva ut lista framlnges mha rekursion
void skriv_framlanges(Element *forsta) {
	if (forsta) {
		std::cout << forsta->data << ' ';
		skriv_framlanges(forsta->nasta);
	}
}

void test4() {
	Element *forsta = nullptr; // Brja med tom lista

	Element *e = sok(forsta, 5); // Sk i tom lista

	lagg_sist_rek(forsta, 4);
	lagg_sist_rek(forsta, 5);
	lagg_sist_rek(forsta, 2);
	e = sok(forsta, 5);		// Sk efter element som finns
	e = sok(forsta, 7);		// Sk efter element som inte finns
	skriv_baklanges(forsta);  cout << endl;

	lagg_sist_rek(forsta, 7);
	e = sok(forsta, 5);		// Sk efter element som finns
	e = sok(forsta, 7);		// Sk efter element som nu finns
	skriv_baklanges(forsta);  cout << endl;
	skriv_framlanges(forsta);  cout << endl;

	tom(forsta);
}

// <<<<<<<<<<<<<<<<  main   >>>>>>>>>>>>>>>>>>>>>>
int main() {
	test1();
//	test23();
//	test4();

	cin >> ws;

}
